{
   INIT for Billy 2.1
   Copyright (C) 2000 Greg Leedberg

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    The full license can be found in the included file license.txt.

    Any questions regarding what you may do with the software can be sent to
    Greg Leedberg, at greg@leedberg.com.

    The full, unedited source follows. 
}

program BillyInit;
uses crt;

type PassKey = string[5];

(***********************************************************************)
function NewKey : PassKey;

var Key : PassKey;
    Rnum : integer;

begin
  Key := chr(random(100)+14) + chr(random(100)+14) + chr(random(100)+14) + chr(random(100)+14);
  rnum := random(4) +2;
  Key[rnum] := chr(random(52)+14);
  Key[1] := chr(rnum);
  NewKey := Key;
end;

(***********************************************************************)
function enc(TextString : string; Key : PassKey) : string;

var loop: integer;
    Adjust : longint;

begin
  Adjust := ord(Key[ord(Key[1])]);
  for loop := 1 to length(TextString) do TextString[loop] := chr(ord(TextString[loop])+Adjust);
  enc := TextString;
end;


(********************************************************************)
procedure EncryptFiles;


procedure Work(FileName : string);

var InFile,OutFile : text;
    Adjust, loop : integer;
    Key : PassKey;
    TextString : string;

begin
  Key := NewKey;
  assign(InFile,FileName+'.BFB');
  assign(OutFile,FileName+'.BFB');
  reset(InFile);
  rewrite(OutFile);
  writeln(OutFile,Key);
  while not eof(InFile) do
    begin
      readln(InFile,TextString);
      writeln(OutFile,enc(TextString,Key));
    end;
  close(InFile);
  close(OutFile);
  erase(InFile);

end;

begin
  write('Encrypting files...');
  Work('br');
  Work('sr');
  Work('is1');
  Work('is2');
  Work('is3');
  writeln('!');
end;

(*************************************************************)
procedure run;

var BillyFile : text;
    YN : char;

begin
  textbackground(0); textcolor(7);
  writeln('WARNING!! Continuing will erase the contents of BiLLY''s ');
  writeln('brain files!!');
  writeln;
  write('Continue? (Y/N) ');
  readln(YN);
  if upcase(YN) = 'Y' then
    begin
  write('BR.BFB...');
  assign(BillyFile,'br.BFB');
  rewrite(BillyFile);
  writeln(BillyFile,'I''m not too sure about that...');
  writeln(BillyFile,'Tell more, please!');
  writeln(BillyFile,'Whoa, there!');
  close(BillyFile);
  writeln('!');

  write('NOUNS.BFB...');
  assign(BillyFile,'nouns.bfb');
  rewrite(BillyFile);
  writeln(BillyFile,'car');
  writeln(BillyFile,'house');
  close(BillyFile);
  writeln('!');

  write('IS1.BFB...');
  assign(BillyFile,'is1.BFB');
  rewrite(BillyFile);
  writeln(BillyFile,'up ');
  close(BillyFile);
  writeln('!');

  write('IS2.BFB...');
  assign(BillyFile,'is2.BFB');
  rewrite(BillyFile);
  writeln(BillyFile,'not too much, really! ');
  close(BillyFile);
  writeln('!');

  write('IS3.BFB...');
  assign(BillyFile,'is3.BFB');
  rewrite(BillyFile);
  writeln(BillyFile,'***');
  close(BillyFile);
  writeln('!');

  write('PAUSE.BFB...');
  assign(BillyFile,'pause.bfb');
  rewrite(BIllyFile);
  writeln(BillyFile,'60');
  writeln(BillyFile,'19');
  writeln(BillyFile,'10');
  writeln(BillyFile,'15');
  writeln(BillyFile,'0');
  close(BillyFile);
  writeln('!');

  write('PEOPLE.BFB...');
  assign(BillyFile,'people.bfb');
  rewrite(BillyFile);
  close(BillyFile);
  writeln('!');

  write('SR.BFB...');
  assign(BillyFile,'sr.BFB');
  rewrite(BillyFile);
  close(BillyFile);
  writeln('!');

  write('SENT.BFB...');
  assign(BillyFile,'sent.BFB');
  rewrite(BillyFile);
  writeln(BillyFile,'Can I have your ');
  writeln(BillyFile,'?');
  close(BillyFile);
  writeln('!');

  write('AD.BFB...');
  assign(BillyFile,'ad.bfb');
  rewrite(BillyFile);
  writeln(BillyFile,'BIG');
  writeln(BillyFile,'CONSIDERABLE');
  writeln(BillyFile,'EXTENSIVE');
  writeln(BillyFile,'HEFTY');
  writeln(BillyFile,'LARGE');
  writeln(BillyFile,'MAJOR');
  writeln(BillyFile,'SIZABLE');
  writeln(BillyFile,'FAT');
  writeln(BillyFile,'GREAT');
  writeln(BillyFile,'HUSKY');
  writeln(BillyFile,'PREGNANT');
  writeln(BillyFile,'HEAVY');
  writeln(BillyFile,'FULL');
  writeln(BillyFile,'CRAMMED');
  writeln(BillyFile,'CROWDED');
  writeln(BillyFile,'JAMMED');
  writeln(BillyFile,'IMPORTANT');
  writeln(BillyFile,'CONSEQUENTIAL');
  writeln(BillyFile,'MEANINGFUL');
  writeln(BillyFile,'MOMENTUS');
  writeln(BillyFile,'SIGNIFICANT');
  writeln(BillyFile,'SUBSTANTIAL');
  writeln(BillyFile,'WEIGHTY');
  writeln(BillyFile,'SMALL');
  writeln(BillyFile,'BLACK');
  writeln(BillyFile,'WHITE');
  writeln(BillyFile,'RED');
  writeln(BillyFile,'BLUE');
  writeln(BillyFile,'GREEN');
  writeln(BillyFile,'YELLOW');
  writeln(BillyFile,'UGLY');
  writeln(BillyFile,'BEAUTIFUL');
  writeln(BillyFile,'CUTE');
  writeln(BillyFile,'WARM');
  writeln(BillyFile,'HOT');
  writeln(BillyFile,'SLOW');
  writeln(BillyFile,'FAST');
  writeln(BillyFile,'LITTLE');
  writeln(BillyFile,'STUPID');
  writeln(BillyFile,'DUMB');
  writeln(BillyFile,'SWEET');
  writeln(BillyFile,'BEST');
  writeln(BillyFile,'WORST');
  writeln(BillyFile,'GOOD');
  writeln(BillyFile,'BAD');
  writeln(BillyFile,'SAME');
  writeln(BillyFile,'MOST');
  writeln(BillyFile,'COOLEST');
  writeln(BillyFile,'LAMEST');
  writeln(BillyFile,'DUMBEST');
  writeln(BillyFile,'VIOLENT');
  writeln(BillyFile,'PEACEFUL');
  writeln(BillyFile,'COMPLETE');
  writeln(BillyFile,'ALMIGHTY');
  writeln(BillyFile,'NEW');
  writeln(BillyFile,'OLD');
  writeln(BillyFile,'WRONG');
  writeln(BillyFile,'RIGHT');
  writeln(BillyFile,'SMILING');
  writeln(BillyFile,'AMERICAN');
  writeln(BillyFile,'OBVIOUS');
  writeln(BillyFile,'NICE');
  close(BillyFile);
  writeln('!');

  write('UDLP.NFO...');
  assign(BillyFile,'udlp.nfo');
  rewrite(BillyFile);
  writeln(BillyFile,'1');
  writeln(BillyFile,'0');
  writeln(BillyFile,'BILLY.EXE');
  writeln(BillyFile,'Billy');
  writeln(BillyFile,'0');
  close(BillyFile);
  writeln('!');
  writeln('Done!');
  writeln;
  writeln('If you also wish to edit the transcripts in BILLY.TXT, ');
  writeln('you may do so manually using a text editor such as DOS ');
  writeln('EDIT or Windows NotePad.');
  writeln;
  writeln('Would you like to completely erase the transcripts in ');
  write('BILLY.TXT now? (Y/N)');
  readln(YN);
  if upcase(YN) = 'Y' then
    begin
      write('BILLY.TXT...');
      assign(BillyFile,'billy.txt');
      rewrite(BillyFile);
      close(BillyFile);
      writeln('!');
    end;
  end;
end;

begin
  run;
end.